Attribute VB_Name = "basFormDrucken"
' *******************************
' Beispiel: Ausdrucken eines Formulars ber API-Aufrufe
' basFormDrucken - Allgemeines Modul
' Das Visual Basic 6.0 Kompendium
' Peter Monadjemi, Markt&Technik 1998
' *******************************Option Explicit
' Deklaration der bentigten API-Funktionen.
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function RealizePalette Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function SelectPalette Lib "gdi32" (ByVal hdc As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Declare Function CreatePalette Lib "gdi32" (lpLogPalette As LOGPALETTE) As Long
Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hdc As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, _
ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long
' Diese Konstanten werden auf API-Ebene bentigt.
Public Const BI_RGB = 0&
Public Const PLANES = 14
Public Const GMEM_MOVEABLE = &H2
Public Const DIB_RGB_COLORS = 0
Public Const RC_PALETTE = &H100
Public Const RASTERCAPS = 38
Public Const SIZEPALETTE = 104
Public Const BITSPIXEL = 12
' Strukturen fr das Standard Picture-Objekt.
Private Type PicBmp
    Size As Long
    Type As Long
    hBmp As Long
    hPal As Long
    Reserved As Long
End Type
Private Type GUID
    Data1 As Long
    Data2 As Integer
    data3 As Integer
    data4(7) As Byte
End Type
Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
' Struktur fr die logische Palette.
Type PALETTEENTRY
        peRed As Byte
        peGreen As Byte
        peBlue As Byte
        peFlags As Byte
End Type
Type LOGPALETTE
        palVersion As Integer
        palNumEntries As Integer
        palPalEntry(255) As PALETTEENTRY
End Type
' Diese Variablen werden prozedurbergreifend bentigt.
Public BreitePictureObjektAnDrucker As Double
Public HhePictureObjektAnDrucker As Double
   
' Hier wird der Inhalt eines Formulars zur Bitmap im Speicher verarbeitet.
Public Function FormEinfrieren(ByVal hWndQuelle As Long, ByVal QuelleLinks As Long, _
ByVal QuelleOben As Long, ByVal QuelleBreite As Long, ByVal QuelleHhe As Long) As Picture
    Dim hDCSpeicher As Long
    Dim hBmp As Long
    Dim hBmpPrev As Long
    Dim Zurck As Long
    Dim hDCQuelle
    Dim hPal As Long
    Dim hPalPrev As Long
    Dim RasterCapsScrn
    Dim JaPaletteDa As Long
    Dim GrePaletteScrn As Long
    Dim LogischePalette As LOGPALETTE
' Der Gertekontext des Innenbereichs der Form wird ermittelt.
    hDCQuelle = GetDC(hWndQuelle)
' Ein gertekompatibler Gertekontext wird im Speicher angelegt.
    hDCSpeicher = CreateCompatibleDC(hDCQuelle)
' Der Gertekontext einer gertekompatiblen Bitmap wird angelegt.
    hBmp = CreateCompatibleBitmap(hDCQuelle, QuelleBreite, QuelleHhe)
' Dieser wird in den Speicher gelegt. hBmpPrev ist jetzt der neue Hndle.
    hBmpPrev = SelectObject(hDCSpeicher, hBmp)
' Paletteninformation der Quelle wird ermittelt.
    RasterCapsScrn = GetDeviceCaps(hDCQuelle, RASTERCAPS)
    JaPaletteDa = RasterCapsScrn And RC_PALETTE
    GrePaletteScrn = GetDeviceCaps(hDCQuelle, SIZEPALETTE)
' Ist eine Palette vorhanden?
    If JaPaletteDa And (GrePaletteScrn = 256) Then
' Falls ja, wird eine entsprechende Kopie als logische Palette angelegt.
        LogischePalette.palVersion = &H300
        LogischePalette.palNumEntries = 256
' Die logische Palette wird gefllt.
        Zurck = GetSystemPaletteEntries(hDCQuelle, 0, 256, LogischePalette.palPalEntry(0))
' Ein Handle auf diese Palette wird erzeugt.
        hPal = CreatePalette(LogischePalette)
' Dieser wird in den Speicher gelegt.
        hPalPrev = SelectPalette(hDCSpeicher, hPal, 0)
' Die neue Palette wird aktiviert.
        Zurck = RealizePalette(hDCSpeicher)
    End If
' Der Inhalt der Quelle wird nun in den vorbereiteten Speicher kopiert.
    Zurck = BitBlt(hDCSpeicher, 0, 0, QuelleBreite, QuelleHhe, hDCQuelle, QuelleLinks, QuelleOben, vbSrcCopy)
' hBmp wird der Handle nun im Speicher fertig vorliegenden Bitmap.
    hBmp = SelectObject(hDCSpeicher, hBmpPrev)
    If JaPaletteDa And (GrePaletteScrn = 256) Then
        hPal = SelectPalette(hDCSpeicher, hPalPrev, 0)
    End If
' Gertekontext des Speichers wieder lschen und die der Quelle und des Ziels wieder lsen.
    Zurck = DeleteDC(hDCSpeicher)
    Zurck = ReleaseDC(hWndQuelle, hDCQuelle)
' Der Handle der kreierten gertekompatiblen Bitmap und der Handle der dazugehrigen Palette
' wird zu weiteren Verarbeitung bergeben.
    Set FormEinfrieren = ErzeugePictureObjekt(hBmp, hPal)
End Function
' Die Bitmap im Speicher wird zum Standard Picture-Objekt gewandelt.
Public Function ErzeugePictureObjekt(ByVal hBmp As Long, ByVal hPal As Long) As Picture
    Dim Pic As PicBmp
    Dim IPic As Picture
    Dim IID_IDispatch As GUID
    Dim Zurck As Long
    
' Notwendige Strukturen fr das Standard Picture-Objekt.
    With IID_IDispatch
        .Data1 = &H20400
        .data4(0) = &HC0
        .data4(7) = &H46
    End With
    With Pic
        .Size = Len(Pic)
        .Type = vbPicTypeBitmap
        .hBmp = hBmp
        .hPal = hPal
    End With
' Der Cloe des Beispiels. Hier wird das PictureObjekt aus dem Handle der gertekompatiblen Bitmap
' und der dazugehrigen Palette erzeugt.
    Zurck = OleCreatePictureIndirect(Pic, IID_IDispatch, 1, IPic)
' bergabe des PictureObjekts.
    Set ErzeugePictureObjekt = IPic
End Function
Public Function FormAuswhlen(frmQuelle As Form) As Picture
' Das Quellformular wird festgelegt.
    Set FormAuswhlen = FormEinfrieren(frmQuelle.hwnd, 0, 0, frmQuelle.ScaleX(frmQuelle.ScaleWidth, frmQuelle.ScaleMode, vbPixels), _
    frmQuelle.ScaleY(frmQuelle.ScaleHeight, frmQuelle.ScaleMode, vbPixels))
End Function
' Skalierung des Druckbereiches.
Sub DruckenVorbereiten(Drucker As Printer, PictureObjekt As Picture)
    Const vbHiMetric = 8
    Dim SeitenverhltnisPictureObjekt As Double
    Dim BreiteDrucker As Double
    Dim HheDrucker As Double
    Dim SeitenverhltnisDrucker As Double
' Die Orientierung der Druckausgabe wird ermittelt.
    If PictureObjekt.Height >= PictureObjekt.Width Then
        Drucker.Orientation = vbPRORLandscape
    Else
        Drucker.Orientation = vbPRORPortrait
    End If
' Seitenverhltnis der PictureObjekts wird ermittelt.
    SeitenverhltnisPictureObjekt = PictureObjekt.Width / PictureObjekt.Height
    BreiteDrucker = Drucker.ScaleX(Drucker.ScaleWidth, Drucker.ScaleMode, vbHiMetric)
    HheDrucker = Drucker.ScaleY(Drucker.ScaleHeight, Drucker.ScaleMode, vbHiMetric)
' Seitenverhltnis des Printer-Objekts wird ermittelt.
    SeitenverhltnisDrucker = BreiteDrucker / HheDrucker
    If SeitenverhltnisPictureObjekt >= SeitenverhltnisDrucker Then
        BreitePictureObjektAnDrucker = Drucker.ScaleX(BreiteDrucker, vbHiMetric, Drucker.ScaleMode)
        HhePictureObjektAnDrucker = Drucker.ScaleY(BreiteDrucker / SeitenverhltnisPictureObjekt, vbHiMetric, Drucker.ScaleMode)
    Else
        BreitePictureObjektAnDrucker = Drucker.ScaleY(HheDrucker, vbHiMetric, Drucker.ScaleMode)
        HhePictureObjektAnDrucker = Drucker.ScaleX(HheDrucker * SeitenverhltnisPictureObjekt, vbHiMetric, Drucker.ScaleMode)
    End If
End Sub
' Das Standard PictureObjekt wird in einem Bildfeld zur Druckvorschau ausgegeben.
Sub DruckerVorschau(PictureObjekt As Picture, ZielBildfeld As PictureBox)
    Dim SeitenverhltnisAnDrucker As Double
' Skalierung des Bildfeldes der Druckvorschau.
    SeitenverhltnisAnDrucker = BreitePictureObjektAnDrucker / HhePictureObjektAnDrucker
    ZielBildfeld.ScaleWidth = ZielBildfeld.ScaleWidth / SeitenverhltnisAnDrucker
    ZielBildfeld.ScaleHeight = ZielBildfeld.ScaleHeight * SeitenverhltnisAnDrucker
' Das PictureObjekt wird ausgegeben.
    ZielBildfeld.PaintPicture PictureObjekt, 0, 0, ZielBildfeld.ScaleWidth, ZielBildfeld.ScaleHeight
   ' ZielBildfeld.Visible = True
End Sub
' Das Standard PictureObjekt wird am Drucker ausgegeben.
Sub Drucken(Drucker As Printer, PictureObjekt As Picture)
' Das PictureObjekt wird an den Drucker skaliert ausgegeben.
    Drucker.PaintPicture PictureObjekt, 0, 0, BreitePictureObjektAnDrucker, HhePictureObjektAnDrucker
    Drucker.EndDoc
End Sub
