VERSION 5.00
Begin VB.UserControl usrLaufwerke 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.DriveListBox drvLaufwerksliste 
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Top             =   840
      Visible         =   0   'False
      Width           =   1215
   End
   Begin VB.CommandButton cmdLaufwerke 
      Caption         =   "Command1"
      Height          =   495
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   615
   End
   Begin VB.Image imgLaufwerkBild 
      Height          =   480
      Index           =   2
      Left            =   2280
      Top             =   2520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgLaufwerkBild 
      Height          =   480
      Index           =   4
      Left            =   2040
      Top             =   2520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgLaufwerkBild 
      Height          =   480
      Index           =   6
      Left            =   1560
      Top             =   2520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgLaufwerkBild 
      Height          =   480
      Index           =   3
      Left            =   1080
      Top             =   2520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgLaufwerkBild 
      Height          =   480
      Index           =   5
      Left            =   600
      Top             =   2520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgLaufwerkBild 
      Height          =   480
      Index           =   0
      Left            =   120
      Top             =   2520
      Visible         =   0   'False
      Width           =   480
   End
End
Attribute VB_Name = "usrLaufwerke"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ************************************************************
' Kapitel 20
' Benutzersteuerelement, das Laufwerksinformationen zurckgibt
' Peter Monadjemi, 1998 Markt&Technik
' ************************************************************
Option Explicit

Public Event Click(LaufwerksName As String, Laufwerkstyp As String, _
 LaufwerksBild As Picture)

Private Declare Function GetDriveType Lib "kernel32" Alias _
     "GetDriveTypeA" (ByVal sDrive As String) As Long

Enum enumLaufwerktypen
     DRIVE_TYPE_UNDTERMINED
     DRIVE_ROOT_NOT_EXIST
     DRIVE_REMOVABLE
     DRIVE_FIXED
     DRIVE_REMOTE
     DRIVE_CDROM
     DRIVE_RAMDISK
End Enum

Private mLaufwerkTyp As String
Private mLaufwerkIndex As enumLaufwerktypen
Private mLaufwerksBild As Picture
Private mLaufwerksBildNr As Long

Enum enumBorderStyle
    Keine
    Fest
End Enum

Property Get LaufwerkTyp() As String
    LaufwerkTyp = mLaufwerkTyp
End Property

Property Let BorderStyle(tmpBorderWert As enumBorderStyle)
    UserControl.BorderStyle = tmpBorderWert
    PropertyChanged "BorderStyle"
End Property

Property Get BorderStyle() As enumBorderStyle
    BorderStyle = UserControl.BorderStyle
End Property

Property Get Picture() As StdPicture
    Set Picture = imgLaufwerkBild(mLaufwerkIndex)
End Property

Private Sub cmdLaufwerke_Click(Index As Integer)
    Dim tmpLaufwerkName As String
    tmpLaufwerkName = cmdLaufwerke(Index).Caption
    mLaufwerkTyp = LaufwerkTypBestimmen(tmpLaufwerkName)
    Set mLaufwerksBild = imgLaufwerkBild(mLaufwerksBildNr)
    RaiseEvent Click(tmpLaufwerkName, mLaufwerkTyp, mLaufwerksBild)
End Sub

Private Sub UserControl_Initialize()
    Dim n As Integer
    For n = 0 To drvLaufwerksliste.ListCount - 1
        If n > 0 Then
           Load cmdLaufwerke(n)
           cmdLaufwerke(n).Left = cmdLaufwerke(n - 1).Left + cmdLaufwerke(0).Width * 1.1
           cmdLaufwerke(n).Top = cmdLaufwerke(0).Top
        End If
        cmdLaufwerke(n).Caption = UCase(Left(drvLaufwerksliste.List(n), 2))
        cmdLaufwerke(n).Visible = True
    Next n
    n = n - 1
    UserControl.Width = cmdLaufwerke(n).Left + cmdLaufwerke(0).Width * 1.2
    UserControl.Height = cmdLaufwerke(0).Height * 1.5
End Sub

Private Sub UserControl_InitProperties()
    BorderStyle = Fest
End Sub

Private Function LaufwerkTypBestimmen(Laufwerkname As String) As String
     Dim LaufwerkID As Integer
     LaufwerkID = GetDriveType(Laufwerkname & "\")
     mLaufwerkIndex = LaufwerkID
     Select Case LaufwerkID
     Case DRIVE_TYPE_UNDTERMINED
          mLaufwerkTyp = "undefiniert"
          mLaufwerksBildNr = 0
       Case DRIVE_ROOT_NOT_EXIST
          mLaufwerkTyp = "nicht vorhanden"
          mLaufwerksBildNr = 0
       Case DRIVE_CDROM
          mLaufwerkTyp = "CD-ROM-Laufwerk"
          mLaufwerksBildNr = 5
       Case DRIVE_FIXED
          mLaufwerkTyp = "Festplatte (nicht entfernbar)"
          mLaufwerksBildNr = 3
       Case DRIVE_RAMDISK
          mLaufwerkTyp = "RAM-Disk"
          mLaufwerksBildNr = 6
       Case DRIVE_REMOTE
          mLaufwerkTyp = "Netzwerklaufwerk (Remote-Laufwerk)"
          mLaufwerksBildNr = 4
       Case DRIVE_REMOVABLE
          mLaufwerkTyp = "Diskettenlaufwerk (entfernbar)"
          mLaufwerksBildNr = 2
     End Select
     LaufwerkTypBestimmen = mLaufwerkTyp
End Function

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    BorderStyle = PropBag.ReadProperty("BorderStyle", 1)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "BorderStyle", BorderStyle, 1
End Sub
